//tommmy code :3c
(function() {
	if($modLoader.knownMods.has("saveloadplus")){
		//=============================================================================
		// * Make Command List
		//=============================================================================
		Window_OmoriFileStats.prototype.updateStats = function (valid, info, id) {
		  this.contents.clear();
		  this.contents.fontSize = 30;
		  this.contents.drawText('FILE ' + id + ':', 1, 1, 130, this.contents.fontSize, 'center');
		  if (valid) {
			this.contents.drawText(info.chapter, 1, 31, 130, this.contents.fontSize, 'center');
			var actor = info.actorData;
			// Draw Actor Name
			this.contents.fontSize = 24;
			// Draw Level
			this.contents.drawText('LEVEL: '+actor.level, 1, 67, 130, 24, 'center');
			// Draw Total PlayTime
			this.contents.drawText('PLAYTIME:', 1, 93, 130, 24, 'center');
			this.contents.drawText(info.playtime, 1, 117, 130, 24, 'center');
			// Draw Location
			this.contents.drawText('LOCATION:', 1, 143, 130, 24, 'center');
			this.contents.drawText(info.location, 1, 167, 130, 24, 'center');
		  }
		  var color = 'rgba(182, 255, 0, 1)';
		  this.contents.fillRect(0, 64, this.contents.width, 3, color);
		  this.contents.fillRect(8, 92, this.contents.width - 16, 1, color);
		  this.contents.fillRect(8, 142, this.contents.width - 16, 1, color);
		  this.contents.fillRect(8, 191, this.contents.width - 16, 1, color);
		};
		//=============================================================================	
		// * Refresh	
		//=============================================================================	
		//why did i change refresh to need parameters?	
		//because i am dumb and could not get moveGame function to work with DataManager.loadGlobalData :<	
		Window_OmoriFileInformation.prototype.refresh = function(valid, info, id) {	
		  // Clear Contents	
		  this.contents.clear();	
		  // Get Color	
		  var color = 'rgba(182, 255, 0, 1)';	
		  // Get ID	
		  //var id = this._index + 1;	
		  //var valid = DataManager.isThisGameFile(id);	
		  //var info = DataManager.loadSavefileInfo(id);	
		  // Draw Lines	
		  this.contents.fillRect(0, 29, this.contents.width, 3, color);	
		  for (var i = 0; i < 3; i++) {	
			var y = 55 + (i * 25)	
			this.contents.fillRect(113, y, this.contents.width - 117, 1, color);	
		  };	
		  // Draw File	
		  this.contents.fontSize = 30;	
		  if(this._columns === 1)this.contents.drawText('FILE ' + id + ':', 10 + 30, -5, 100, this.contents.fontSize);	
		  else{	
			if(!valid || info.saveName === null || info.saveName === "" ||info.saveName === undefined)this.contents.drawText(id, 2, -5, 100, this.contents.fontSize, 'center');	
			else this.contents.drawText(info.saveName, 2, -5, 98, this.contents.fontSize, 'center');	
		  }	
			
		  // If Valid	
		  if (valid) {	
			if(this._select){	
			  this._faceSprite.visible = true;	
			  this._selectedBG.visible = true;	
			}else{	
			  this._faceSprite.visible = false;	
			  this._selectedBG.visible = false;	
			}	
			this.contents.drawText(info.chapter, 85 + 30 + 13*Math.floor(Math.log10(id)), -5, this.contents.width, this.contents.fontSize);	
			this.contents.fontSize = 28;	
			let backBitmap = ImageManager.loadSystem('loadscreen_backgrounds');	
			let width = 100;	
			let height = 100;	
			// this.contents.blt(backBitmap, 0, 0, width, height, 0, 34, width + 10, height);	
			bgLocation = getBackground(info.location);	
			this.contents.blt(backBitmap, width*bgLocation[0], height*bgLocation[1], width, height, 1, 33); //width*n, height*m controls background	
			this._selectedBG.setFrame(width*bgLocation[0], height*bgLocation[1], width, height);	
			// Get Actor	
			var actor = info.actorData;	
			// Draw Actor Face	
			this.drawFace(actor.faceName, 0, -2, this.contents.height - Window_Base._faceHeight + 7, Window_Base._faceWidth, height - 2);	
			this._faceSprite.actor = actor;	
			if(omoDelete)this._faceSprite.setAnimRow(3);	
			else this._faceSprite.setAnimRow(0);	
			// Draw Actor Name	
			this.contents.fontSize = 24;	
			if(info.saveName === null || info.saveName === "" || info.saveName === undefined)this.contents.drawText(actor.name, 118, 30, 200, 24);	
			else this.contents.drawText(info.saveName, 118, 30, 200, 24);	
			// Draw Level	
			this.contents.drawText('LEVEL:', 290 + 55, 30, 100, 24);	
			this.contents.drawText(actor.level, 290 + 55, 30, 70, 24, 'right');	
			// Draw Total PlayTime	
			this.contents.drawText('TOTAL PLAYTIME:', 118, 55, 200, 24);	
			this.contents.drawText(info.playtime, 295 + 55, 55, 100, 24);	
			// Draw Location	
			this.contents.drawText('LOCATION:', 118, 80, 200, 24);	
			this.contents.drawText(info.location, 205, 80, 210, 24, 'right');	
		  }else{	
			this._faceSprite.visible = false;	
			this._selectedBG.visible = false;	
		  };	
		  // Draw Border	
		  this.contents.fillRect(102, 32, 3, 102, 'rgba(182, 255, 0, 1)')	
		  this.contents.fillRect(0, 29, 108, 3, 'rgba(182, 255, 0, 1)')	
		};	
	}else{
		Window_OmoriFileInformation.prototype.refresh = function() {	
			// Clear Contents	
			this.contents.clear();	
			// Get Color	
			var color = 'rgba(182, 255, 0, 1)';	
			// Get ID	
			var id = this._index + 1;	
			var valid = DataManager.isThisGameFile(id);	
			var info = DataManager.loadSavefileInfo(id);	
			
			// Draw Lines	
			this.contents.fillRect(0, 29, this.contents.width, 3, color);	
			for (var i = 0; i < 3; i++) {	
			  var y = 55 + (i * 25)	
			  this.contents.fillRect(113, y, this.contents.width - 117, 1, color);	
			};	
			
			
			// Draw File	
			this.contents.fontSize = LanguageManager.getMessageData("XX_BLUE.Window_OmoriFileInformation").refresh_contents_fontsize;	
			let loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoriFileInformation").file_position	
			this.contents.drawText(LanguageManager.getMessageData("XX_BLUE.Omori_Save_Load").file.format(id), loc_position[0], loc_position[1], 100, this.contents.fontSize);	
			// If Valid	
			if (valid) {	
			  loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoriFileInformation").refresh_drawText_position;	
			  let chap = LanguageManager.getMessageData("XX_BLUE.Chapter_Names")[info.chapter]	
			  if(!chap) {	
				chap = info.chapter	
			  }	
			  this.contents.drawText(chap, loc_position[0], loc_position[1], this.contents.width, this.contents.fontSize);	
			  this.contents.fontSize = 28;	
			
			  let backBitmap = ImageManager.loadSystem('faceset_states');	
			  let width = backBitmap.width / 4;	
			  let height = backBitmap.height / 5;	
			  // this.contents.blt(backBitmap, 0, 0, width, height, 0, 34, width + 10, height);	
			  this.contents.blt(backBitmap, 0, 0, width, height, 1, 33);	
			  // Get Actor	
			  var actor = info.actorData	
			  // Draw Actor Face	
			  let bit = ImageManager.loadFace(actor.faceName);	
			  bit.addLoadListener(() => this.drawFace(actor.faceName, actor.faceIndex, -2, this.contents.height - Window_Base._faceHeight + 7, Window_Base._faceWidth, height - 2));	
			  // Draw Actor Name	
			  this.contents.fontSize = 24;	
			  this.contents.drawText(actor.name, 118, 30, 100, 24);	
			  // Draw Level	
			  loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoriFileInformation").level_position;	
			  this.contents.drawText(LanguageManager.getMessageData("XX_BLUE.Omori_Save_Load").level, loc_position[0], loc_position[1], 100, 24);	
			  this.contents.drawText(actor.level, loc_position[0], loc_position[1], 70, 24, 'right');	
			  // Draw Total PlayTime	
			  loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoriFileInformation").playtime_position;	
			  this.contents.drawText(LanguageManager.getMessageData("XX_BLUE.Omori_Save_Load").playtime, 118, 55, 200, 24);	
			  this.contents.drawText(info.playtime, loc_position[0], loc_position[1], 100, 24);	
			  // Draw Location	
			  this.contents.drawText(LanguageManager.getMessageData("XX_BLUE.Omori_Save_Load").location, 118, 80, 200, 24);	
			  this.contents.drawText(info.location, 205, 80, 210, 24, 'right');	
			};	
			
			// Draw Border	
			this.contents.fillRect(102, 32, 3, 102, 'rgba(182, 255, 0, 1)')	
			this.contents.fillRect(0, 29, 108, 3, 'rgba(182, 255, 0, 1)')	
		};
	}
})();

Sprite_MapCharacterTagFace.prototype.createBackgroundSprite = function() {
    var bitmap = new Bitmap(110, 110 + 34)
    bitmap.fillAll('rgba(0, 0, 0, 1)')
    bitmap.fillRect(1, 1, bitmap.width - 2, bitmap.height - 2, 'rgba(182, 255, 0, 1)')
    bitmap.fillRect(4, 4, bitmap.width - 8, 105, 'rgba(0, 0, 0, 1)')
    bitmap.fillRect(0, 113, bitmap.width, 1, 'rgba(0, 0, 0, 1)')
    bitmap.fillRect(4, 117, bitmap.width - 8, 22, 'rgba(0, 0, 0, 1)')
    this._backgroundSprite = new Sprite(bitmap);
    this._backgroundSprite.x = -(bitmap.width / 2);  
    this._backgroundSprite.y = -(110 / 2);    
    this.addChild(this._backgroundSprite);
};

Sprite_MapCharacterTagFace.prototype.createFaceSprite = function() {
    // Create Face Sprite
    this._faceSprite = new Sprite_OmoMenuStatusFace();
    this._faceSprite.anchor.set(0.5, 0.5)
    this._faceSprite.actor = $gameParty.members()[0];
    this._faceSprite.deactivate();
    this.addChild(this._faceSprite);
    this._faceMask = new Sprite(new Bitmap(110,110))
    this._faceMask.x = -(110 / 2) + 2;  
    this._faceMask.y = -(110 / 2) + 2;  
    let white = 'rgba(182, 255, 0, 1)';
    this._faceMask.bitmap.fillRect(0,0,106,2, white)
    this._faceMask.bitmap.fillRect(104,0,2,106, white)
    this.addChild(this._faceMask);
};

Window_OmoMainMenuActorStatus.prototype.refresh = function() {	
	// Clear Contents	
	this.contents.clear();	
	// Get Actor	
	var actor = this.actor();	
	// If Actor Exists	
	if (actor) {	
	  // Get World Index	
	  let worldIndex = SceneManager.currentWorldIndex();	
	  // Set Face Sprite Actor	
	  this._faceSprite.actor = actor;	
	  this._faceSprite.y = -this._faceSprite.height;	
	  this._faceSprite.x = Math.floor(143 / 2);	
	  this.contents.textColor = 'rgba(0, 0, 0, 1)';	
	  this.contents.outlineWidth = 0;	
	  this.contents.fontSize = LanguageManager.getMessageData("XX_BLUE.Window_OmoMainMenuActorStatus").refresh_contents_fontsize;	
	  let loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoMainMenuActorStatus").refresh_drawText_position;	
	  this.drawText(actor.name(), loc_position[0], loc_position[1], this.contents.width);	
	  this.contents.fontSize = LanguageManager.getMessageData("XX_BLUE.Window_OmoMainMenuActorStatus").refresh_contents_fontsize2;	
	  this.contents.textColor = 'rgba(255, 255, 255, 1)';	
	  // If world index is not 2	
	  if (worldIndex !== 2) {	
		// Get Exp Rate parts	
		let exp = actor.currentLevelExp();	
		let currentExp = actor.currentExp() - exp;	
		let nextExp = actor.nextLevelExp() - exp;	
		// Set Rate	
		let rate = currentExp / nextExp;	
		rate = Math.min(rate, 1);	
		this.contents.gradientFillRect(2, 30, 151 * rate, 15, 'rgba(51, 0, 196, 1)', 'rgba(254, 145, 246, 1)');	
		this.drawText("%1 %2".format(LanguageManager.getMessageData("XX_BLUE.Omori_Mainmenu").lvl, actor._level), 12, 18, this.contents.width);	
	  };	
	  // Get Bar Bitmap	
	  var bitmap = ImageManager.loadSystem('newtagmenud');	
	  // Draw HP Bar & HP	
	  this.contents.blt(bitmap, 0, 109, 116 * actor.hpRate(), 14, 29, 56);	
	  loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoMainMenuActorStatus").refresh_drawTextHP_position;	
	  this.drawText(actor.hp + '/' + actor.mhp, loc_position[0], loc_position[1], this.contents.width - 26, 'right');	
	  // Draw MP Bar & MP	
	  loc_position = LanguageManager.getMessageData("XX_BLUE.Window_OmoMainMenuActorStatus").refresh_drawTextMP_position;	
	  this.contents.blt(bitmap, 0, 123, 116 * actor.mpRate(), 14, 29, 84  );	
	  this.drawText(actor.mp + '/' + actor.mmp, loc_position[0], loc_position[1], this.contents.width - 26, 'right');	
	};	
};

Window_OmoMenuActorEquip.prototype.refresh = function() {
    // Run Original Function
    Window_Selectable.prototype.refresh.call(this);
    // Reset Font Settings
    this.resetFontSettings();  
    // Draw Headers
    this.contents.fontSize = 20;
    this.changePaintOpacity(true)  
    this.contents.fillRect(4, 28, this.width - 8, 2, 'rgba(182, 255, 0, 1)');
    this.contents.fillRect(4, 65, this.width - 8, 2, 'rgba(182, 255, 0, 1)');
    this.contents.fillRect(4, 90, this.width - 8, 2, 'rgba(182, 255, 0, 1)');
    this.drawText(LanguageManager.getPluginText('equipMenu', 'weapon'), 0, -4, this.width, 'center');
    this.drawText(LanguageManager.getPluginText('equipMenu', 'charm'), 0, 58, this.width, 'center');
};

Window_OmoMenuEquipStatus.prototype.makeBubbleBitmap = function(size) {
    // Create Bitmap
    var bitmap = new Bitmap(size * 2, size * 2);
  //  bitmap.fillAll('rgba(255, 0, 0, 1)')  
    // Set X & Y
    var x = size, y = size;
    // Draw Circle
    bitmap.drawCircle(x, y, size, 'rgba(0, 0, 0, 1)')
    bitmap.drawCircle(x, y, size - 1, 'rgba(182, 255, 0, 1)');
    bitmap.drawCircle(x, y, size - 3, 'rgba(0, 0, 0, 1)')    
    // Return Bitmap
    return bitmap
};

Window_OmoMenuActorSkillEquip.prototype.refresh = function() {
    // Run Original Function
    Window_Selectable.prototype.refresh.call(this);
    // Reset Font Settings
    this.resetFontSettings();
    // Draw Headers
    this.contents.fontSize = 20;
    this.changePaintOpacity(true)  
    this.contents.fillRect(4, 28, this.width - 8, 2, 'rgba(182, 255, 0, 1)');
    this.drawText(LanguageManager.getPluginText('skillMenu', 'skills'), 0, -4, this.width, 'center');  
};

Window_OmoMenuSkillEquipControl.prototype.makeBubbleBitmap = function(size) {
    // Create Bitmap
    var bitmap = new Bitmap(size * 2, size * 2);
    // Set X & Y
    var x = size, y = size;
    // Draw Circle
    bitmap.drawCircle(x, y, size, 'rgba(0, 0, 0, 1)')
    bitmap.drawCircle(x, y, size - 1, 'rgba(182, 255, 0, 1)');
    bitmap.drawCircle(x, y, size - 3, 'rgba(0, 0, 0, 1)')    
    // Return Bitmap
    return bitmap
};


  
  Scene_OmoriPhotoAlbum.prototype.createViewingSprites = function() {
    // Create Viewing Picture
    this._viewingPicture = new Sprite_OmoriAlbumBigPicture();
    this.addChild(this._viewingPicture);
    // Create Viewing Picture Slide
    this._viewingPictureSlide = new Sprite_OmoriAlbumBigPicture();
    this.addChild(this._viewingPictureSlide);
  
  
    // this._bigPictureSprite = new Sprite_OmoriAlbumBigPicture();
    // this._bigPictureSprite.x = Graphics.width  / 2;
    // this._bigPictureSprite.y = Graphics.height / 2;
    // this.addChild(this._bigPictureSprite );
  
  
    // Get Pointer Bitmap
    var pointerBitmap = ImageManager.loadSystem('ACSArrows');
    // Create Box Bitmap
    var boxBitmap = new Bitmap(45, 25);
    boxBitmap.fillAll('rgba(0, 0, 0, 1)')
    boxBitmap.fillRect(1, 1, boxBitmap.width - 2, boxBitmap.height - 2, 'rgba(182, 255, 0, 1)');
    boxBitmap.fillRect(4, 4, boxBitmap.width - 8, boxBitmap.height - 8, 'rgba(0, 0, 0, 1)');
  
    // // Get Pointer Bitmap
    // var pointerBitmap = ImageManager.loadSystem('ACSArrows');
    // // Create Box Bitmap
    // var boxBitmap = new Bitmap(55, 40);
    // boxBitmap.fillAll('rgba(0, 0, 0, 1)')
    // boxBitmap.fillRect(1, 1, boxBitmap.width - 2, boxBitmap.height - 2, 'rgba(255, 255, 255, 1)');
    // boxBitmap.fillRect(4, 4, boxBitmap.width - 8, boxBitmap.height - 8, 'rgba(0, 0, 0, 1)');
  
    // Create Viewing Picture Left Box
    this._viewingPictureLeftBox = new Sprite(boxBitmap);
    this._viewingPictureLeftBox.x = -this._viewingPictureLeftBox.width;
    this._viewingPictureLeftBox.y = (Graphics.height - this._viewingPictureLeftBox.height - 125) / 2;
    this._viewingPictureLeftBox.opacity = 0;
    this.addChild(this._viewingPictureLeftBox);
    // Create Viewing Picture Box Pointer Sprite
    this._viewingPictureLeftBox._pointerSprite = new Sprite(pointerBitmap);
    this._viewingPictureLeftBox._pointerSprite.x = 4;
    this._viewingPictureLeftBox._pointerSprite.y = -2;
    this._viewingPictureLeftBox._pointerSprite.setFrame(2 * 32, 0, 32, 32);
    this._viewingPictureLeftBox.addChild(this._viewingPictureLeftBox._pointerSprite);
  
    // Create Viewing Picture Right Box
    this._viewingPictureRightBox = new Sprite(boxBitmap);
    this._viewingPictureRightBox.x = (Graphics.width - this._viewingPictureRightBox.width);
    this._viewingPictureRightBox.y = (Graphics.height - this._viewingPictureRightBox.height - 125) / 2;
    this._viewingPictureRightBox.opacity = 0;
    this.addChild(this._viewingPictureRightBox);
    // Create Viewing Picture Box Pointer Sprite
    this._viewingPictureRightBox._pointerSprite = new Sprite(pointerBitmap);
    this._viewingPictureRightBox._pointerSprite.x = 38;
    this._viewingPictureRightBox._pointerSprite.y = -2;
    this._viewingPictureRightBox._pointerSprite.scale.x = -1;
    this._viewingPictureRightBox._pointerSprite.setFrame(2 * 32, 0, 32, 32);
    this._viewingPictureRightBox.addChild(this._viewingPictureRightBox._pointerSprite);
  
    // Get Flip Text
    var text = LanguageManager.getPluginText('albumMenu', 'flipText');
    var flipWidth = pointerBitmap.measureTextWidth(text);
    var flipBitmap = new Bitmap(flipWidth + 80, 30);
  
    flipBitmap.drawInputIcon('shift', 0, 4, false);
    flipBitmap.drawText(text, 0, -5, flipBitmap.width, flipBitmap.height, 'center');
    // flipBitmap.blt(pointerBitmap, 2 * 32, 0, 32, 29, 4, 0)
    // flipBitmap.blt(pointerBitmap, 1 * 32, 0, 32, 29, flipBitmap.width - 36, 0)
    // Create Flip Picture Box
    this._flipPictureBox = new Sprite(flipBitmap)
    this._flipPictureBox.x = (Graphics.width - flipBitmap.width) / 2
    this._flipPictureBox.y = Graphics.height - 30;
    this._flipPictureBox.opacity = 0;
    this.addChild(this._flipPictureBox);
  };
  
  Sprite_OmoriPictureAlbum.prototype.createPageLegendSprite = function() {
    // Create Bitmap
    var bitmap = new Bitmap(this._backgroundSprite.width + 130, 60);
    bitmap.fillAll('rgba(32, 32, 32, 0.5)')
    // bitmap.drawText('←', 5, 20, 40, 32)
    // bitmap.drawText('→', bitmap.width - 35, 20, 40, 32);
  
    var width = 60//48
    bitmap.fillRect(0, 0, width, bitmap.height, 'rgba(0, 0, 0, 1)')
    bitmap.fillRect(1, 1, width - 2, bitmap.height - 2, 'rgba(182, 255, 0, 1)')
    bitmap.fillRect(4, 4, width - 8, bitmap.height - 8, 'rgba(0, 0, 0, 1)')
    bitmap.fillRect(bitmap.width - width, 0, width, bitmap.height, 'rgba(0, 0, 0, 1)')
    bitmap.fillRect((bitmap.width - width) + 1, 1, width - 2, bitmap.height - 2, 'rgba(182, 255, 0, 1)')
    bitmap.fillRect((bitmap.width - width) + 4, 4, width - 8, bitmap.height - 8, 'rgba(0, 0, 0, 1)')
    bitmap.clearRect(width, 0, bitmap.width - (width * 2), bitmap.height);
  
    // Draw Input Icons
    bitmap.drawAlginedKeyIcon(Input.inputKeyCode('pageup'), 0, 5, width, 32, 'center')
    bitmap.drawAlginedKeyIcon(Input.inputKeyCode('pagedown'), bitmap.width - width, 5, width, 32, 'center')
  
    // Create Page Legend Sprite
    this._pageLegendSprite = new Sprite(bitmap);
    this._pageLegendSprite.x = -50 - 15;
    // this._pageLegendSprite.y = (this._backgroundSprite.height - this._pageLegendSprite.height)  / 2;
    // this._pageLegendSprite.y = this._backgroundSprite.height - this._pageLegendSprite.height
    // this._pageLegendSprite.y = -this._pageLegendSprite.height;
    this.addChild(this._pageLegendSprite);
  };

  Window_OmoBlackLetterList.prototype.drawItem = function(index) {
	// Get Item Rect
	var rect = this.itemRect(index);
	// Get Data
	var data = this._list[index].ext;
	// Draw Clue
	this.contents.fontSize = 24;
	this.changeTextColor(this.textColor(0))
	this.drawText(data.clue, 75, rect.y - 5, rect.width - 135, rect.height);
	// Adjust Rect
	rect.x = rect.width - (rect.height + 10)
	rect.height -= 6
	rect.width = rect.height;
	// Draw Blackletter Text
	this.drawBlackLetterText(data.letter, 35, rect.y);
	// Move rect Y
	rect.y += 3;
	// Fill Check mark box
	this.contents.fillRect(rect.x, rect.y, rect.width, rect.height, 'rgba(182, 255, 0, 1)');
	this.contents.clearRect(rect.x + 3, rect.y + 3, rect.width - 6, rect.height - 6);
	// Change Font Size
	this.contents.fontSize = 20;
	// Get State (Right, Wrong, Empty)
	var state = 2;
	// If Item is obtained
	if ($gameParty.hasItem($dataItems[data.itemId])) {
	  // Set State
	  state = this._hangmanWord.contains(data.letter) ? 0 : 1;
	};
	// Get Symbol
	var symbol = ['✓', '✕', ''][state];
	// Get Color
	var color = [3, 2, 0][state];
  
	var symbolsImage = ImageManager.loadSystem('HangmanStates');
	this.contents.blt(symbolsImage, 20 * state, 0, 20, 20, rect.x + 5, rect.y + 4, 20, 20);
  };